### Hierarchy

- AtomControl
  - AtomPage

### Implements

- IAtomComponent<IAtomElement>
- INotifyPropertyChanged

## Index

### Constructors

- constructor

### Properties

- app
- defaultControlStyle
- disposables
- element
- pendingInits
- tag
- title
- isControl

### Accessors

- controlStyle
- data
- localViewModel
- parent
- theme
- viewModel
- vsProps

### Methods

- append
- atomParent
- beginEdit
- bind
- bindEvent
- create
- dispose
- hasProperty
- invalidate
- onPropertyChanged
- onUpdateSize
- onUpdateUI
- preCreate
- registerDisposable
- removeAllChildren
- render
- resolve
- runAfterInit
- setElementClass
- setElementValue
- setLocalValue
- setPrimitiveValue
- unbind
- unbindEvent
- updateSize

## Constructors

### constructor

- new AtomPage(app: App, e?: HTMLElement): AtomPage

- Inherited from AtomControl.constructor

  Overrides AtomComponent.constructor

  - Defined in src/web/controls/AtomControl.ts:105

  #### Parameters

  - ##### app: App

  - ##### Optional e: HTMLElement

  #### Returns AtomPage

## Properties

### app

app: App

Implementation of IAtomComponent.app

Inherited from AtomComponent.app

- Defined in src/core/AtomComponent.ts:132

### defaultControlStyle

defaultControlStyle: any

Inherited from AtomControl.defaultControlStyle

- Defined in src/web/controls/AtomControl.ts:46

### disposables

disposables: AtomDisposableList

Inherited from AtomComponent.disposables

- Defined in src/core/AtomComponent.ts:44

### element

element: HTMLElement

Implementation of IAtomComponent.element

Inherited from AtomComponent.element

- Defined in src/core/AtomComponent.ts:46

### Protected pendingInits

pendingInits: Array<function>

Inherited from AtomComponent.pendingInits

- Defined in src/core/AtomComponent.ts:48

### tag

tag: string

- Defined in src/web/controls/AtomPage.ts:8

### title

title: string

- Defined in src/web/controls/AtomPage.ts:6

### Static isControl

isControl: true = true

Inherited from AtomComponent.isControl

- Defined in src/core/AtomComponent.ts:41

## Accessors

### controlStyle

- get controlStyle(): AtomStyle
- set controlStyle(v: AtomStyle): void

- Inherited from AtomControl.controlStyle

  - Defined in src/web/controls/AtomControl.ts:49

  #### Returns AtomStyle

- Inherited from AtomControl.controlStyle

  - Defined in src/web/controls/AtomControl.ts:67

  #### Parameters

  - ##### v: AtomStyle

  #### Returns void

### data

- get data(): any
- set data(v: any): void

- Inherited from AtomComponent.data

  - Defined in src/core/AtomComponent.ts:55

  #### Returns any

- Inherited from AtomComponent.data

  - Defined in src/core/AtomComponent.ts:66

  #### Parameters

  - ##### v: any

  #### Returns void

### localViewModel

- get localViewModel(): any
- set localViewModel(v: any): void

- Inherited from AtomComponent.localViewModel

  - Defined in src/core/AtomComponent.ts:93

  #### Returns any

- Inherited from AtomComponent.localViewModel

  - Defined in src/core/AtomComponent.ts:104

  #### Parameters

  - ##### v: any

  #### Returns void

### parent

- get parent(): AtomControl

- Inherited from AtomControl.parent

  Overrides AtomComponent.parent

  - Defined in src/web/controls/AtomControl.ts:99

  Gets Parent AtomControl of this control.

  #### Returns AtomControl

### theme

- get theme(): AtomStyleSheet
- set theme(v: AtomStyleSheet): void

- Inherited from AtomControl.theme

  - Defined in src/web/controls/AtomControl.ts:86

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Returns AtomStyleSheet

- Inherited from AtomControl.theme

  - Defined in src/web/controls/AtomControl.ts:91

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Parameters

  - ##### v: AtomStyleSheet

  #### Returns void

### viewModel

- get viewModel(): any
- set viewModel(v: any): void

- Inherited from AtomComponent.viewModel

  - Defined in src/core/AtomComponent.ts:72

  #### Returns any

- Inherited from AtomComponent.viewModel

  - Defined in src/core/AtomComponent.ts:83

  #### Parameters

  - ##### v: any

  #### Returns void

### vsProps

- get vsProps(): object | object | __type

- Inherited from AtomComponent.vsProps

  - Defined in src/core/AtomComponent.ts:118

  Do not ever use, only available as intellisense feature for vs code editor.

  #### Returns object | object | __type

## Methods

### append

- append(element: AtomControl | HTMLElement | Text): AtomControl

- Inherited from AtomControl.append

  Overrides AtomComponent.append

  - Defined in src/web/controls/AtomControl.ts:132

  #### Parameters

  - ##### element: AtomControl | HTMLElement | Text

  #### Returns AtomControl

### atomParent

- atomParent(e: HTMLElement): AtomControl

- Inherited from AtomControl.atomParent

  Overrides AtomComponent.atomParent

  - Defined in src/web/controls/AtomControl.ts:121

  #### Parameters

  - ##### e: HTMLElement

  #### Returns AtomControl

### beginEdit

- beginEdit(): IDisposable

- Inherited from AtomComponent.beginEdit

  - Defined in src/core/AtomComponent.ts:375

  #### Returns IDisposable

### bind

- bind(element: HTMLElement, name: string, path: PathList[], twoWays?: boolean | string[], valueFunc?: function, source?: any): IDisposable

- Inherited from AtomComponent.bind

  - Defined in src/core/AtomComponent.ts:147

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### path: PathList[]

  - ##### Optional twoWays: boolean | string[]

  - ##### Optional valueFunc: function

    - - (...v: any[]): any

      - #### Parameters

        - ##### Rest ...v: any[]

        #### Returns any

  - ##### Optional source: any

  #### Returns IDisposable

### bindEvent

- bindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): IDisposable

- Inherited from AtomComponent.bindEvent

  - Defined in src/core/AtomComponent.ts:185

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns IDisposable

### Protected create

- create(): void

- Inherited from AtomComponent.create

  - Defined in src/core/AtomComponent.ts:502

  #### Returns void

### dispose

- dispose(e?: HTMLElement): void

- Inherited from AtomComponent.dispose

  - Defined in src/core/AtomComponent.ts:325

  #### Parameters

  - ##### Optional e: HTMLElement

  #### Returns void

### hasProperty

- hasProperty(name: string): boolean

- Implementation of IAtomComponent.hasProperty

  Inherited from AtomComponent.hasProperty

  - Defined in src/core/AtomComponent.ts:246

  #### Parameters

  - ##### name: string

  #### Returns boolean

### invalidate

- invalidate(): void

- Inherited from AtomComponent.invalidate

  - Defined in src/core/AtomComponent.ts:395

  #### Returns void

### onPropertyChanged

- onPropertyChanged(name: string): void

- Implementation of INotifyPropertyChanged.onPropertyChanged

  Inherited from AtomControl.onPropertyChanged

  Overrides AtomComponent.onPropertyChanged

  - Defined in src/web/controls/AtomControl.ts:111

  #### Parameters

  - ##### name: string

  #### Returns void

### Protected onUpdateSize

- onUpdateSize(): void

- Inherited from AtomControl.onUpdateSize

  - Defined in src/web/controls/AtomControl.ts:301

  #### Returns void

### onUpdateUI

- onUpdateUI(): void

- Inherited from AtomComponent.onUpdateUI

  - Defined in src/core/AtomComponent.ts:407

  #### Returns void

### preCreate

- preCreate(): void

- Overrides AtomControl.preCreate

  - Defined in src/web/controls/AtomPage.ts:10

  #### Returns void

### registerDisposable

- registerDisposable(d: IDisposable): IDisposable

- Inherited from AtomComponent.registerDisposable

  - Defined in src/core/AtomComponent.ts:419

  #### Parameters

  - ##### d: IDisposable

  #### Returns IDisposable

### Protected removeAllChildren

- removeAllChildren(e: HTMLElement): void

- Inherited from AtomControl.removeAllChildren

  - Defined in src/web/controls/AtomControl.ts:305

  #### Parameters

  - ##### e: HTMLElement

  #### Returns void

### Protected render

- render(node: XNode, e?: any, creator?: any): void

- Inherited from AtomComponent.render

  - Defined in src/core/AtomComponent.ts:423

  #### Parameters

  - ##### node: XNode

  - ##### Optional e: any

  - ##### Optional creator: any

  #### Returns void

### Protected resolve

- resolve<TService>(c: TService, selfName?: string | function): IAnyInstanceType<TService>

- Inherited from AtomComponent.resolve

  - Defined in src/core/AtomComponent.ts:514

  #### Type parameters

  - #### TService

  #### Parameters

  - ##### c: TService

  - ##### Optional selfName: string | function

  #### Returns IAnyInstanceType<TService>

### runAfterInit

- runAfterInit(f: function): void

- Inherited from AtomComponent.runAfterInit

  - Defined in src/core/AtomComponent.ts:411

  #### Parameters

  - ##### f: function

    - - (): void

      - #### Returns void

### Protected setElementClass

- setElementClass(element: HTMLElement, value: any, clear?: boolean): void

- Inherited from AtomControl.setElementClass

  - Defined in src/web/controls/AtomControl.ts:263

  #### Parameters

  - ##### element: HTMLElement

  - ##### value: any

  - ##### Optional clear: boolean

  #### Returns void

### Protected setElementValue

- setElementValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomControl.setElementValue

  Overrides AtomComponent.setElementValue

  - Defined in src/web/controls/AtomControl.ts:158

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setLocalValue

- setLocalValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setLocalValue

  - Defined in src/core/AtomComponent.ts:295

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setPrimitiveValue

- setPrimitiveValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setPrimitiveValue

  - Defined in src/core/AtomComponent.ts:260

  Use this method if you want to set attribute on HTMLElement immediately but defer atom control property

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement

  - ##### name: string

    string

  - ##### value: any

    any

  #### Returns void

### unbind

- unbind(element: HTMLElement, name?: string): void

- Inherited from AtomComponent.unbind

  - Defined in src/core/AtomComponent.ts:177

  Remove all bindings associated with given element and optional name

  #### Parameters

  - ##### element: HTMLElement

    T

  - ##### Optional name: string

    string

  #### Returns void

### unbindEvent

- unbindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): void

- Inherited from AtomComponent.unbindEvent

  - Defined in src/core/AtomComponent.ts:215

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns void

### updateSize

- updateSize(): void

- Inherited from AtomControl.updateSize

  - Defined in src/web/controls/AtomControl.ts:141

  #### Returns void

Generated using TypeDoc